{ 
  TMessinstrument

  erstellt von Roland Gruber  (gruberroland@netscape.net)
  Mrz 2000

  Diese Komponente darf in kommerziellen Anwendungen sowie
  zum privaten Gebrauch verwendet werden, solange der Name
  des Programmierers genannt wird (z.B. in einer Info-Box).

  Der Gebrauch der Komponente erfolgt auf eigene Gefahr
  und fr etweige Schden wird keine Haftung bernommen.
  (Auch wenn die Wahrscheinlichkeit dafr eher gering ist.)

  Wenn Sie diese Komponente verbessern oder Anregungen
  haben wrde ich mich ber eine e-mail freuen.
  (gruberroland@netscape.net)

  Erklrung der Funktionen:

  Aussehen: legt fest, ob das instrument als Zeigernadel, Vertikaler
            Balken, Horizontaler Balken oder Kuchendiagramm erscheint
  Hintergrundfarbe: Farbe des Hintergrunds
  Vordergrundfarbe: Farbe des Vordergrunds
  Mittelgrundfarbe: aktuell Farbe der Zeigernadel
  Minimum: minimaler Wert des Fortschritts
  Maximum: maximaler Wert des Fortschritts
  Fortschritt: Gre des Messwertes
  Wert: eingeblendeter Wert
  WertZeigen: legt fest, ob der Wert und die Einheit eingeblendet werden
  Einheit: String fr die Einheit des eingeblendeten Wertes
}


unit Messinstrument;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, math;

type
  Taussehen=(Zeiger,BalkenHorizontal,BalkenVertikal,Kuchendiagramm) ;
  TMessinstrument = class(TPaintBox)
  private
    { Private-Deklarationen}
    faussehen:Taussehen;
    fhinterfarbe:Tcolor;
    fvorderfarbe:Tcolor;
    fmittelfarbe:tcolor;
    fminimum:integer;
    fmaximum:integer;
    ffortschritt:integer;
    feinheit:string;
    fwert:string;
    fwertzeigen:boolean;
    procedure aktualisieren;
    procedure balkenhorzeichnen;
    procedure balkenverzeichnen;
    procedure kuchenzeichnen;
    procedure zeigerzeichnen;
    procedure ruecksetzen;
    procedure aussehenaendern(value:taussehen);
    procedure maxaendern(value:integer);
    procedure minaendern(value:integer);
    procedure fortaendern(value:integer);
    procedure hinterfarbeaendern(value:tcolor);
    procedure vorderfarbeaendern(value:tcolor);
    procedure mittelfarbeaendern(value:tcolor);
    procedure einheitaendern(value:string);
    procedure wertaendern(value:string);
    procedure wertzeigenaendern(value:boolean);
    property Color;
  protected
    { Protected-Deklarationen}
    procedure paint;override;
  public
    { Public-Deklarationen}
    constructor create(aowner : Tcomponent);override;
  published
    { Published-Deklarationen }
    property Aussehen:Taussehen read faussehen write aussehenaendern;
    property HintergrundFarbe:Tcolor read fhinterfarbe write hinterfarbeaendern;
    property VordergrundFarbe:Tcolor read fvorderfarbe write vorderfarbeaendern;
    property Mittelgrundfarbe:Tcolor read fmittelfarbe write mittelfarbeaendern;
    property Minimum:integer read fminimum write minaendern;
    property Maximum:integer read fmaximum write maxaendern;
    property Fortschritt:integer read ffortschritt write fortaendern;
    property Wert:string read fwert write wertaendern;
    property WertZeigen:boolean read fwertzeigen write wertzeigenaendern;
    property Einheit:string read feinheit write einheitaendern;
end;

procedure Register;

implementation

constructor tmessinstrument.Create(AOwner: Tcomponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csFramed, csOpaque];
  fmaximum:=100;
  fMinimum:=0;
  ffortschritt:=75;
  color:=clwhite;
  fvorderfarbe:=clblue;
  fhinterfarbe:=clblack;
  fmittelfarbe:=clwhite;
  faussehen:=balkenvertikal;
end;

procedure tmessinstrument.paint;
begin
aktualisieren ;
end;

procedure tmessinstrument.aussehenaendern;
begin
faussehen:=value;
aktualisieren;
end;

procedure tmessinstrument.maxaendern;
begin
fmaximum:=value;
aktualisieren;
end;

procedure tmessinstrument.minaendern;
begin
fminimum:=value;
aktualisieren;
end;

procedure tmessinstrument.fortaendern;
begin
ffortschritt:=value;
aktualisieren;
end;

procedure tmessinstrument.hinterfarbeaendern;
begin
fhinterfarbe:=value;
aktualisieren;
end;

procedure tmessinstrument.vorderfarbeaendern;
begin
fvorderfarbe:=value;
aktualisieren;
end;

procedure tmessinstrument.mittelfarbeaendern;
begin
fmittelfarbe:=value;
aktualisieren;
end;

procedure tmessinstrument.einheitaendern;
begin
feinheit:=value;
aktualisieren;
end;

procedure tmessinstrument.wertaendern;
begin
fwert:=value;
aktualisieren;
end;

procedure tmessinstrument.wertzeigenaendern;
begin
fwertzeigen:=value;
aktualisieren;
end;

procedure tmessinstrument.aktualisieren;
var hoehe,breite,x,y:integer;
var text:string;
begin
canvas.Font:=font;
if ffortschritt > fmaximum then ffortschritt:=fmaximum;
if ffortschritt < fminimum then ffortschritt:=fminimum;
ruecksetzen;
case faussehen of balkenvertikal: balkenverzeichnen;
                  balkenhorizontal: balkenhorzeichnen;
                  zeiger: zeigerzeichnen;
                  kuchendiagramm: kuchenzeichnen;
       end;
if fwertzeigen=true then begin
text:=(wert+einheit);
hoehe:=canvas.textheight(text);
breite:=canvas.textwidth(text);
x:=((width-breite) div 2);
y:=((height-hoehe) div 2);
canvas.textout(x,y,text);
end;       
end;

procedure tmessinstrument.zeigerzeichnen; 
var x,y:integer;
var a:real;
begin
canvas.pen.color:=fvorderfarbe;
canvas.Brush.Color:=fvorderfarbe;
canvas.ellipse(0,0,width,(height*2));
if ffortschritt=0 then exit;
canvas.pen.color:=fmittelfarbe;
canvas.Brush.Color:=fmittelfarbe;
canvas.Pen.Width:=2;
a:=((ffortschritt / fmaximum) * 2 * pi);
canvas.moveto((width div 2),height);
x:=trunc((width / 2) * (1 - cos(a/2)));
y:=trunc(height*(1 - sin(a/2)));
canvas.lineto(x,y);
end;

procedure tmessinstrument.kuchenzeichnen;
var x,y:integer;
var a:real;
begin
if ffortschritt=0 then exit;
canvas.pen.color:=fhinterfarbe;
canvas.Brush.Color:=fvorderfarbe;
a:=((ffortschritt / fmaximum) * 2 * pi);
x:=trunc((width / 2) * (1+sin(a)));
y:=trunc((height / 2)*(1 - cos(a)));
canvas.pie(0,0,width,height,x,y,(width div 2),0);
end;

procedure tmessinstrument.balkenverzeichnen;
var breite:int64;
begin
if ffortschritt=0 then exit;
canvas.pen.color:=fvorderfarbe;
canvas.Brush.Color:=fvorderfarbe;
breite:=width;
breite:=((breite * ffortschritt) div fmaximum);
canvas.rectangle(0,0,breite,height);
end;

procedure tmessinstrument.balkenhorzeichnen;
var hoehe:int64;
begin
if ffortschritt=0 then exit;
canvas.pen.color:=fvorderfarbe;
canvas.Brush.Color:=fvorderfarbe;
hoehe:=Height;
hoehe:=(hoehe-((hoehe * ffortschritt) div fmaximum));
canvas.rectangle(0,height,width,hoehe);
end;

procedure tmessinstrument.ruecksetzen;
begin
canvas.pen.color:=fhinterfarbe;
canvas.brush.color:=fhinterfarbe;
Canvas.rectangle(0,0,width,height);
end;

procedure Register;
begin
  RegisterComponents('Roland', [TMessinstrument]);
end;

end.

